; Program asks to write a string
; Then it finds big and low letters (upper/lower case)

.model small
.stack
.data
	msg1 db "Iveskite: $"			; predefined strings
	msg2 db 0dh, 0ah, "Turime eilute: $"	; 0dh and 0ah means CR and LF, that means a new line character :)
	msg3 db 0dh, 0ah, "Didziuju: $"
	msg4 db 0dh, 0ah, "Mazuju: $"
	ivedbuf db 255				; input buffer. this byte stores max. length of string
		db 0				; this byte stores current length of string (po ivedimo)
		db 255 dup(0)			; here characters are stored, zero is duplicated 255 times.
.code
	mov ax, @data				; moving data segment's address to ds using ax
	mov ds, ax
	
	mov dx, offset msg1			; moving an offset of first message to dx
	call rasyti				; and function is called
	
	mov dx, offset ivedbuf			; moving an offset of input buffer to the dx
	call skaityti				; and function for buffered input is called
						; length of string is stored in second byte
						; all the characters are stored in those 255 duplicated bytes
	
	mov dx, offset msg2			; same shit, printing message
	call rasyti
	
						; now we have to print that buffered string
	mov ch, [ivedbuf+1]			; here we are creating a loop index, using as the first value the length of string
	inc ch					; incrementing that (+1), so we are counting not from n to 0, but from n+1 to 1.
	mov si, offset ivedbuf+2		; we must move offset of that buffer (remember that duplicated shit?) to si
						; .. which will increment each time "lodsb" is used. That's for printing one
						; .. character per loop, but each loop will be used the next character :).
	printout:
		lodsb				; here is the lodsb, it moves current character to the AL register, and then
						; .. increments SI by one.
		cmp ch, 0			; we are comparing each time CH index, and when it equals ZERO, we..
		je endprintout			; .. ending this stuff. :).
		dec ch				; .. but if it is not zero, we are decreasing it.
		mov dl, al			; We have a character created by lodsb in al. Moving it to dl, for using interrupt.
		mov ah, 02			; And moving appropriate interrupt code into ah
		int 21h				; Calling that interrupt with code 02 (it prints character stored in register DL)
		jmp printout			; Going back and doing all the shit again
	endprintout:				; And this is a jump point, when CH is reached zero, look above (cmp ch, 0)
	
	mov dx, offset msg3			; Now we printing one more shit on the display
	call rasyti
	
						; .. And this is the deepest shit in this program
	mov ch, [ivedbuf+1]			; Moving string length into CH again
	inc ch					; .. incrementing by one
	mov bh, 0				; This is the counter, how much big letters we have. Initially it is 0.
	mov si, offset ivedbuf+2		; That's for lodsb, look above.
	uppercase:
		lodsb				; Pasting char to AL, incrementing SI
		cmp ch, 0			; Looking for having a zero in CH
		je enduppercase			; .. and ending this shit, if it does
		dec ch				; .. if not, decreasing CH
		sub al, 41h			; Now, we have a char code in AL. All big characters begin from 41h
						; .. so were substracting all unnesesary codes outa here
		cmp al, 19h			; And looking, is the char goes into the 0-19h interval.
		jbe bigone			; if the code is below or equal 19h, it is a BIG letter, jumping to the "bigone"
		jmp uppercase			; other way, that wasn't a BIG char, and moving to the next char.
	bigone:
		inc bh				; incrementing BH (big letter counter) by one
		jmp uppercase			; and moving to the next char (doing all again)
	enduppercase:				; This is launched, when CH = 0
		add bh, 30h			; We have to add to BH also 30h, because digits in ASCII table are beginning from 30h.
		mov dl, bh			; Moving BH to dl for printing out
		mov ah, 02h			; op. code
		int 21h				; printing out.
		
	mov dx, offset msg4			; Boring... xD
	call rasyti
		
	mov ch, [ivedbuf+1]			; This is same as the above. But it reads string for small characters.
	inc ch
	mov bh, 0
	mov si, offset ivedbuf+2
	lowercase:
		lodsb
		cmp ch, 0
		je endlowercase
		dec ch
		sub al, 61h			; All small characters are beginning from 61h
		cmp al, 19h			; And there is 19h of them. (27 desimtaineje)
		jbe smallone
		jmp lowercase
	smallone:
		inc bh
		jmp lowercase
	endlowercase:
		add bh, 30h			; printing char
		mov dl, bh
		mov ah, 02h
		int 21h
	
	mov ax, 04c00h				; program ends
	int 21h					; and dies hard.
	
	
	
	
	rasyti proc
		mov ah, 09h			; printing function
		int 21h
		ret
	rasyti endp
	
	skaityti proc
		mov ah, 0ah			; buffered input function, it uses ivedbuf as buffer.
		int 21h
		ret
	skaityti endp
	
end